# -*- mode: rpm-spec; coding: utf-8 -*-
%define base_name      dbus
%define version        0.36.2
%define source_name    %base_name
%define source_version %version
%define release        alt1

# QT bindings are broken at the moment
%def_enable qt
%def_disable static

%if_enabled qt
%def_with cvs_dbusqt
%if_with cvs_dbusqt
%define dbusqt_snap 20050130
%endif
%endif

%def_disable mono

%define dbus_maj       1
%define dbus_min       0

%define dbus_user      messagebus
%define dbus_group     messagebus

%define system_socket_dir /var/run/dbus
%define session_socket_dir %system_socket_dir/users

%define system_socket %system_socket_dir/system_bus_socket

%define mono_prefix /usr/lib/mono

Name:    %base_name
Version: %version
Release: %release

Summary: D-BUS is a simple IPC framework based on messages.
Summary(ru_RU.UTF-8): D-BUS это простая среда межпроцессного взаимодействия, построенная на сообщениях
License: GPL or Academic Free License
Group: System/Servers
Url: http://www.freedesktop.org/Software/dbus

Requires: lib%name = %version, shadow-utils
# Only new, fresh, carefully selected and 'you-cant-live-without' build requirements
# buildreq, hmm, well, you know...
BuildRequires: doxygen xmlto libexpat-devel libgtk+2-devel gcc-c++

Source0: http://freedesktop.org/Software/dbus/%name-%version.tar.gz
#Source1: http://freedesktop.org/Software/dbus/%name-docs.tar.bz2 
# (gb) 0.22-2mdk fix detection of moc path
Source100: dbus_descr_en.txt
Source200: dbus_descr_ru.txt
# Mdk patches
Patch2: dbus-0.22-qt-moc.patch.bz2
#-------------------------------------------

Patch10: dbus-0.23-alt-ac_qt_check.patch 
Patch111: dbus-0.34-qtfixes.patch
Patch11: dbus-qt.patch
Patch14: dbus-0.34-altify_init_script.patch
Patch15: dbus-0.22-alt-gcj-parallel-make.patch
Patch16: dbus-0.22-alt-mono-parallel-make.patch
Patch17: dbus-0.23-alt-gcj-fPIC.patch

%define descr_en %(cat %SOURCE100)

%define descr_ru %(cat %SOURCE200)

%description
%descr_en

This package contains D-BUS daemon and system utilities

%description -l ru_RU.UTF-8
%descr_ru

В этом пакете находятся сервер и системные утилиты D-BUS 

%package tools
Summary: D-BUS user helper tools
Summary(ru_RU.UTF-8): Пользовательские утилиты D-BUS
Group: Monitoring
Provides: dbus-userhelpers = %version-%release
Obsoletes: dbus-userhelpers

%description tools
%descr_en


This package includes user tools for launching D-BUS service on session startup

%description -l ru_RU.UTF-8 tools
%descr_ru

В данный пакет включены пользовательские утилиты для запуска сервиса D-BUS при старте сессии

%package tools-gui
Summary:  D-BUS user helper tools
Group: Monitoring

%description tools-gui
%descr_en

This package includes user tools for launching D-BUS service on session startup

%package -n lib%name
Summary: D-BUS shared libraries
Group: System/Libraries
%description -n lib%name
%descr_en

This package contains D-BUS shared libraries

%description -n lib%name -l ru_RU.UTF-8
%descr_ru

В этом пакете находятся разделяемые библиотеки D-BUS 

%package -n lib%name-devel
Summary: D-BUS development files
Group: Development/C
Requires: lib%name = %version-%release
%description -n lib%name-devel
%descr_en

This package contains D-BUS development files (headers and libraries links)

%description -n lib%name-devel -l ru_RU.UTF-8
%descr_ru

В этом пакете находятся файлы для разработки с использованием D-BUS (заголовочные
файлы и библиотеки)

%if_enabled static
%package -n  lib%name-devel-static
Summary: D-BUS static libraries
Group: Development/C
Requires: lib%name-devel = %version-%release
%description -n lib%name-devel-static
%descr_en

This package contains D-BUS static development libraries

%description -n lib%name-devel-static -l ru_RU.UTF-8
%descr_ru

В этом пакете находятся статические библиотеки разработки для D-BUS
%endif

%package -n lib%name-glib
Summary: GLib bindings for D-BUS
Group: System/Libraries
Requires: lib%name = %version-%release
BuildRequires: glib2-devel
%description -n lib%name-glib
%descr_en

This package contains D-BUS library wrapper suitable for applications
which make use of GLib event loop.

%package -n lib%name-glib-devel
Summary: GLib bindings development files for D-BUS
Group: Development/C
Requires: lib%name-glib = %version-%release
Requires: lib%name-devel = %version-%release
Requires: glib2-devel
%description -n lib%name-glib-devel
%descr_en

This package contains GLib bindings development files for D-BUS

%if_enabled static
%package -n lib%name-glib-devel-static
Summary: GLib bindings development files for D-BUS
Group: Development/C
Requires: lib%name-glib-devel = %version-%release
BuildRequires: glib2-devel-static
%description -n lib%name-glib-devel-static
%descr_en

This package contains GLib bindings static libraries for D-BUS
%endif

%if_enabled qt
%package -n lib%name-qt
Summary: Qt3 bindings for D-BUS
Group: System/Libraries
Requires: lib%name = %version-%release
BuildRequires: libqt3-devel
%description -n lib%name-qt
%descr_en

This package contains D-BUS library wrapper suitable for Qt3-based
applications

%package -n lib%name-qt-devel
Summary: Qt3 bindings development files for D-BUS
Group: Development/C++
Requires: lib%name-qt = %version-%release
Requires: lib%name = %version-%release
Requires: lib%name-devel = %version-%release
Requires: libqt3-devel
%description -n lib%name-qt-devel
%descr_en

This package contains Qt3 bindings development files for D-BUS
%endif

%package -n lib%name-gcj
Summary: GCJ bindings for D-BUS
Group: Development/Java
Requires: lib%name = %version-%release
BuildRequires: gcc-java
%description -n lib%name-gcj
%descr_en

This package contains GCJ bindings (shared libs) for D-BUS

%if_enabled mono
%package -n lib%name-mono
Summary: Mono bindings for D-BUS
Group: Development/Other
Requires: lib%name = %version-%release
Requires: mono >= 1.0
BuildRequires: mono >= 1.0
BuildRequires: mono-devel
%description -n  lib%name-mono
%descr_en

This package contains Mono bindings (shared libs) for D-BUS

%package -n lib%name-monodoc
Summary: Mono bindings documentation for D-BUS in monodoc format
Requires: lib%name-mono = %version-%release
Group: Development/Other
BuildRequires: monodoc
%description -n  lib%name-monodoc
%descr_en

This package contains Mono bindings documentation for D-BUS in Monodoc format
%endif

%setup_python_subpackage dbus
%package -n %packagename
Summary: Python bindings for D-BUS library
Group: Development/Python
Prefix: %_prefix
%setup_std_python_package_deps
BuildRequires: %py_package_dependencies Pyrex >= 0.9.3-alt2
BuildPreReq: rpm-build-python >= 0.20-alt1
Requires: lib%name = %version



%description -n %packagename
%descr_en

Python bindings for D-BUS library

%prep
%setup -q -n %source_name-%source_version
%if_enabled qt
%patch2 -p1 -b .qt-moc
%patch10 -p1 -b .ac_qt_check
%patch11 -p1 -b .qt_fixes
%patch111 -p1 -b .qt_fixes
%endif
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1

%build
%__libtoolize --copy --force
%__aclocal
%__autoconf
%__automake
# temporary fix for strange ALT Linux mono location
PATH="$PATH:%mono_prefix/bin"
JAR=jar-%__gcc_version_base
PYTHON=$RPM_PYTHON
export PATH JAR PYTHON

%configure %{subst_enable qt} \
	--enable-gcj \
	--enable-glib \
	--enable-gtk \
%if_enabled mono
	--enable-mono \
	--enable-mono-docs \
%else
	--disable-mono \
	--disable-mono-docs \
%endif
	--enable-python \
	--enable-xml-docs \
	--with-x \
	--with-xml=expat \
	--enable-shared \
	%{subst_enable static} \
	--with-system-pid-file=%_var/run/messagebus.pid \
	--with-system-socket=%system_socket \
	--with-session-socket-dir=%session_socket_dir \
	--enable-doxygen-docs \
	--localstatedir=%_var \

%make_build JAR=$JAR

doxygen Doxyfile

mv doc/api/html api

%install
PATH="$PATH:%mono_prefix/bin"
JAR=jar-%__gcc_version_base
PYTHON=$RPM_PYTHON
export PATH JAR PYTHON

%make DESTDIR=%buildroot install

%__mkdir_p %buildroot%system_socket_dir
%__mkdir_p %buildroot%session_socket_dir
chmod 1777 %buildroot%session_socket_dir

%pre
/usr/sbin/groupadd -r -f %dbus_group
/usr/sbin/useradd -r -n -g %dbus_group -d %system_socket_dir -s /dev/null \
	-c "D-Bus System User" %dbus_user ||:
%post
%post_service messagebus

%preun
%preun_service messagebus

%post -n lib%name
%post_ldconfig

%postun -n lib%name
%postun_ldconfig

%post -n lib%name-glib
%post_ldconfig

%postun -n lib%name-glib
%postun_ldconfig

%post -n lib%name-gcj
%post_ldconfig

%postun -n lib%name-gcj
%postun_ldconfig

%files
%config(noreplace) %_sysconfdir/dbus-?/*.conf
%dir %_sysconfdir/dbus-?/system.d
%attr(755,root,root) %config(noreplace) %_initdir/messagebus

%_bindir/dbus-cleanup-sockets
%_bindir/dbus-daemon
%attr(644,root,man) %_mandir/man*/dbus-cleanup-sockets.*
%attr(644,root,man) %_mandir/man*/dbus-daemon.*


%attr(0755,root,root) %dir %system_socket_dir
%attr(1777,root,root) %dir %session_socket_dir

%attr(-,root,root) %_datadir/dbus-?/services

%files tools

%_bindir/dbus-send
%attr(644,root,man) %_mandir/man*/dbus-send.*

%_bindir/dbus-monitor
%attr(644,root,man) %_mandir/man*/dbus-monitor.*


%files tools-gui
%_bindir/dbus-launch
%attr(644,root,man) %_mandir/man*/dbus-launch.*

%_bindir/dbus-viewer

%files -n lib%name
%_libdir/libdbus-?.so.*

%files -n lib%name-devel
%doc doc/TODO doc/dbus-*.html doc/dbus-*.xml doc/dcop-howto.txt
%doc HACKING NEWS README AUTHORS
%doc api

%_libdir/libdbus-?.so
%_includedir/dbus-?.?/dbus
%exclude %_includedir/dbus-?.?/dbus/dbus-glib*
%exclude %_includedir/dbus-?.?/dbus/connection.h
%exclude %_includedir/dbus-?.?/dbus/message.h
%exclude %_includedir/dbus-?.?/dbus/server.h
%exclude %_includedir/dbus-?.?/dbus/dbus-qt*
%_libdir/dbus-?.?
%_libdir/pkgconfig/dbus-?.pc


%if_enabled static
%files -n lib%name-devel-static
%_libdir/libdbus-?.a
%endif


%files -n lib%name-glib
%_libdir/libdbus-glib-?.so.*


%files -n lib%name-glib-devel
%_bindir/dbus-binding-tool
%_libdir/libdbus-glib-?.so
%_includedir/dbus-?.?/dbus/dbus-glib*
%_libdir/pkgconfig/dbus-glib-?.pc


%if_enabled static
%files -n lib%name-glib-devel-static
%_libdir/libdbus-glib-?.a
%endif

%if_enabled qt
%files -n lib%name-qt
%_libdir/libdbus-qt-?.so.*

%files -n lib%name-qt-devel
%_includedir/dbus-?.?/dbus/dbus-qt*
%_includedir/dbus-?.?/dbus/connection.h
%_includedir/dbus-?.?/dbus/message.h
%_includedir/dbus-?.?/dbus/server.h
%_libdir/libdbus-qt-?.so
%endif

# If GCJ really requires .so link?
%files -n lib%name-gcj
%_libdir/libdbus-gcj-1.so*
%_datadir/java/*

%if_enabled mono
%files -n lib%name-mono
%doc mono/example/*cs
%doc mono/example/Makefile
%_libdir/mono
%_libdir/pkgconfig/dbus-sharp.pc


%files -n lib%name-monodoc
%docdir %_libdir/monodoc/sources
%_libdir/monodoc/sources/*
%endif

%files -n %packagename
%dir %_libdir/python%__python_version/site-packages/dbus
%_libdir/python%__python_version/site-packages/dbus.pth
%_libdir/python%__python_version/site-packages/dbus/*.py*
%_libdir/python%__python_version/site-packages/dbus/dbus*.so

%changelog
* Tue Aug 30 2005 Anton Farygin <rider@altlinux.ru> 0.36.2-alt1
- new version

* Fri Aug 26 2005 Anton Farygin <rider@altlinux.ru> 0.36.1-alt1
- new version

* Fri Aug 19 2005 Anton Farygin <rider@altlinux.ru> 0.35.2-alt1
- new version

* Wed Aug 17 2005 Anton Farygin <rider@altlinux.ru> 0.34-alt5
- start messagebus after dm

* Tue Aug 16 2005 Anton Farygin <rider@altlinux.ru> 0.34-alt4
- dbus-qt.h moved to libdbus-qt-devel

* Mon Aug 08 2005 Anton Farygin <rider@altlinux.ru> 0.34-alt3
- verbosing post-scripts
- disabled build for mono

* Wed Aug 03 2005 Anton Farygin <rider@altlinux.ru> 0.34-alt2
- requires fixed for devel packages (#7064)
- headers for dbus-qt moved to libdbus-qt-devel (#6311)

* Tue Jul 12 2005 Anton Farygin <rider@altlinux.ru> 0.34-alt1
- new version
- disabled mono for x86_64

* Fri May 13 2005 Anton Farygin <rider@altlinux.ru> 0.23.4-alt1
- updated to new version
- gui tools moved from dbus-tools to dbus-tools-gui

* Sun Feb 06 2005 Alexey Morozov <morozov@altlinux.org> 0.23-alt2
- Finally managed to compile Qt bindings!
  Some issues are unresolved though. Someone can take a look into
  qt/message.cpp and implement Message copy constructor and
  putting QVariant datatypes to dbus messages.

* Thu Jan 20 2005 Alexey Morozov <morozov@altlinux.org> 0.23-alt1
- New version (0.23)
- Patches from Mandrake are in mainstream now
- mono location workaround is applied for install section too
- -userhelpers subpackage is renamed to -tools as #5341 suggests
- python package is built against recent rpm-build-python specs and
  corresponding python-module-Pyrex

* Sat Jan 15 2005 Vital Khilko <vk@altlinux.ru> 0.22-alt2
- added patches from Mandrake Linux

* Tue Sep  7 2004 Alexey Morozov <morozov@altlinux.org> 0.22-alt1
- Initial build.
